Index: palm/trunk/UTIL/inifor/src/types.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/types.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/src/types.f90	(revision 2696)
@@ -0,0 +1,152 @@
+!> @file src/types.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> The types module provides derived data types used in INIFOR.
+!------------------------------------------------------------------------------!
+ MODULE types
+ 
+ USE defs,                                                                     &
+    ONLY:  dp, PATH, SNAME, LNAME
+ USE netcdf,                                                                   &
+    ONLY:  NF90_MAX_VAR_DIMS, NF90_MAX_NAME
+
+ IMPLICIT NONE
+
+ TYPE grid_definition
+    CHARACTER(LEN=SNAME)  ::  name(3)       !< names of the grid dimensions, e.g. (/'x', 'y', 'z'/) or (/'latitude', 'longitude', 'height'/)
+    INTEGER               ::  nx            !< number of gridpoints in the first dimension
+    INTEGER               ::  ny            !< number of gridpoints in the second dimension
+    INTEGER               ::  nz            !< number of gridpoints in the third dimension
+    INTEGER, ALLOCATABLE  ::  ii(:,:,:)     !< Given a point (i,j,k) in the PALM-4U grid, ii(i,j,l) gives the x index of the l'th horizontl neighbour on the COSMO-DE grid.
+    INTEGER, ALLOCATABLE  ::  jj(:,:,:)     !< Given a point (i,j,k) in the PALM-4U grid, jj(i,j,l) gives the y index of the l'th horizontl neighbour on the COSMO-DE grid.
+    INTEGER, ALLOCATABLE  ::  kk(:,:,:,:)   !< Given a point (i,j,k) in the PALM-4U grid, kk(i,j,k,l) gives the z index of the l'th vertical neighbour in the intermediate grid.
+    REAL(dp)              ::  dx            !< grid spacing in the first dimension [m]
+    REAL(dp)              ::  dy            !< grid spacing in the second dimension [m]
+    REAL(dp)              ::  dz            !< grid spacing in the third dimension [m]
+    REAL(dp)              ::  dxi           !< inverse grid spacing in the first dimension [m^-1]
+    REAL(dp)              ::  dyi           !< inverse grid spacing in the second dimension [m^-1]
+    REAL(dp)              ::  dzi           !< inverse grid spacing in the third dimension [m^-1]
+    REAL(dp)              ::  lx            !< domain length in the first dimension [m]
+    REAL(dp)              ::  ly            !< domain length in the second dimension [m]
+    REAL(dp)              ::  lz            !< domain length in the third dimension [m]
+    REAL(dp)              ::  x0            !< x coordinate of PALM-4U domain projection centre, i.e. location of zero distortion
+    REAL(dp)              ::  y0            !< y coordinate of PALM-4U domain projection centre, i.e. location of zwro distortion
+    REAL(dp)              ::  z0            !< displacement of the coordinate origin above sea level [m]
+    REAL(dp), ALLOCATABLE ::  x(:)          !< coordinates of cell centers in x direction [m]
+    REAL(dp), ALLOCATABLE ::  y(:)          !< coordinates of cell centers in y direction [m]
+    REAL(dp), ALLOCATABLE ::  z(:)          !< coordinates of cell centers in z direction [m]
+    REAL(dp), ALLOCATABLE ::  h(:,:,:)      !< heights grid point for intermediate grids [m]
+    REAL(dp), POINTER     ::  hhl(:,:,:)    !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from 
+    REAL(dp), POINTER     ::  hfl(:,:,:)    !< heights of full layers (cell centres) above sea level in COSMO-DE, computed as arithmetic average of hhl
+    REAL(dp), POINTER     ::  depths(:)     !< depths of output soil layers, equal the depths of the source model (e.g. COSMO-DE)
+    REAL(dp), ALLOCATABLE ::  xu(:)         !< coordinates of cell faces in x direction [m]
+    REAL(dp), ALLOCATABLE ::  yv(:)         !< coordinates of cell faces in y direction [m]
+    REAL(dp), ALLOCATABLE ::  zw(:)         !< coordinates of cell faces in z direction [m]
+    REAL(dp), ALLOCATABLE ::  lat(:)        !< rotated-pole latitudes of scalars (cell centers) of the COSMO-DE grid [rad]
+    REAL(dp), ALLOCATABLE ::  lon(:)        !< rotated-pole longitudes of scalars (cell centres) of the COSMO-DE grid [rad]
+    REAL(dp), ALLOCATABLE ::  latv(:)       !< rotated-pole latitudes of v winds (face centres in latitudal/y direction) [rad]
+    REAL(dp), ALLOCATABLE ::  lonu(:)       !< rotated-pole latitudes of u winds (face centres in longitudal/x direction) [rad]
+    REAL(dp), ALLOCATABLE ::  clat(:,:)     !< latitudes of PALM-4U cell centres in COSMO-DE's rotated-pole grid [rad]
+    REAL(dp), ALLOCATABLE ::  clon(:,:)     !< longitudes of PALM-4U scalars (cell centres) in COSMO-DE's rotated-pole grid [rad]
+    REAL(dp), ALLOCATABLE ::  clatu(:,:)    !< latitudes of PALM-4U u winds (cell faces in u direction) in COSMO-DE's rotated-pole grid [rad]
+    REAL(dp), ALLOCATABLE ::  clonu(:,:)    !< longitudes of PALM-4U u winds (cell faces in u direction) in COSMO-DE's rotated-pole grid [rad]
+    REAL(dp), ALLOCATABLE ::  clatv(:,:)    !< latitudes of PALM-4U v winds (cell faces in v direction) in COSMO-DE's rotated-pole grid [rad]
+    REAL(dp), ALLOCATABLE ::  clonv(:,:)    !< longitudes of PALM-4U v winds (cell faces in v direction) in COSMO-DE's rotated-pole grid [rad]
+    REAL(dp), ALLOCATABLE ::  w_horiz(:,:,:)   !< weights for bilinear horizontal interpolation
+    REAL(dp), ALLOCATABLE ::  w_verti(:,:,:,:) !< weights for linear vertical interpolation
+ END TYPE
+
+
+ TYPE nc_file
+    CHARACTER(LEN=PATH)   ::  name          !< file name
+    INTEGER               ::  dimid_time    !< NetCDF IDs of the time dimension
+    INTEGER               ::  dimids_scl(3) !< NetCDF IDs of the grid dimensions for scalar points x, y, z 
+    INTEGER               ::  dimids_vel(3) !< NetCDF IDs of the grid dimensions for velocity points xu, yu, zu
+    INTEGER               ::  dimids_soil(3)!< NetCDF IDs of the grid dimensions for soil points x, y, depth
+    INTEGER               ::  dimvarid_time !< NetCDF IDs of the time variable
+    INTEGER               ::  dimvarids_scl(3) !< NetCDF IDs of the grid coordinates of scalars x, y, z 
+    INTEGER               ::  dimvarids_vel(3) !< NetCDF IDs of the grid coordinates of velocities xu, yu, zu. Note that velocities are located at mix of both coordinates, e.g. u(xu, y, z).
+    INTEGER               ::  dimvarids_soil(3)!< NetCDF IDs of the grid coordinates for soil points x, y, depth 
+    REAL(dp), POINTER     ::  time(:)       ! vector of output time steps
+ END TYPE
+
+
+ TYPE nc_var
+    INTEGER                               ::  varid     !< NetCDF ID of the variable
+    INTEGER                               ::  input_id  !< ID of the correpsonding input variables, only valid for output variables
+    INTEGER                               ::  ndim      !< number of NetCDF dimensions
+    INTEGER                               ::  nt        !< number of output time steps
+    INTEGER                               ::  lod       !< NetCDF attribute indicating the PALM-4U level of detail
+    INTEGER, DIMENSION(NF90_MAX_VAR_DIMS) ::  dimids    !< NetCDF IDs of the dimensions
+    INTEGER, DIMENSION(NF90_MAX_VAR_DIMS) ::  dimvarids !< IDs of NetCDF dimension variables
+    INTEGER, DIMENSION(NF90_MAX_VAR_DIMS) ::  dimlen    !< length of NetCDF dimensions
+    CHARACTER(LEN=NF90_MAX_NAME), DIMENSION(NF90_MAX_VAR_DIMS) ::  dimname !< names of NetCDF dimensions
+    CHARACTER(LEN=SNAME)                  ::  name                      !< NetCDF short name of the variable
+    CHARACTER(LEN=LNAME)                  ::  standard_name             !< NetCDF standard name of the variable
+    CHARACTER(LEN=LNAME)                  ::  long_name                 !< NetCDF long name of the variable
+    CHARACTER(LEN=LNAME)                  ::  source                    !< NetCDF attribute indicating the data source for the output
+    CHARACTER(LEN=SNAME)                  ::  units                     !< NetCDF units of the variable
+    CHARACTER(LEN=SNAME)                  ::  kind                      !< Kind of grid
+    CHARACTER(LEN=SNAME)                  ::  task                      !< Processing task that generates this variable, e.g. 'interpolate_2d' or 'average profile'
+    LOGICAL                               ::  to_be_processed = .FALSE. !< Inifor flag indicating whether variable shall be processed
+    LOGICAL                               ::  is_read = .FALSE.         !< Inifor flag indicating whether variable has been read
+    LOGICAL                               ::  is_upside_down  = .FALSE. !< Inifor flag indicating whether variable shall be processed
+    TYPE(grid_definition), POINTER        ::  grid                      !< Pointer to the corresponding output grid
+    TYPE(grid_definition), POINTER        ::  intermediate_grid         !< Pointer to the corresponding intermediate grid
+ END TYPE nc_var
+
+
+ TYPE io_group                                          !< Input/Output group, groups together output variabels that share their input variables. For instance, all boundary surfaces and initialization fields of the potential temperature are base on T and p.
+    INTEGER                          ::  nt             !< maximum number of output time steps across all output variables
+    INTEGER                          ::  nv             !< number of output variables
+    CHARACTER(LEN=SNAME)             ::  kind           !< kind of I/O group
+    CHARACTER(LEN=PATH), ALLOCATABLE ::  in_files(:)    !< list of nt input files
+    TYPE(nc_var), ALLOCATABLE        ::  out_vars(:)    !< list of output variables 
+    TYPE(nc_var), ALLOCATABLE        ::  in_var_list(:) !< list of input variables
+    LOGICAL                          ::  to_be_processed = .FALSE. !< Inifor flag indicating whether I/O group shall be processed
+    LOGICAL                          ::  is_accumulated = .FALSE.  !< Flag indicating whether this I/O group contains accumulated variables
+    LOGICAL                          ::  is_preprocessed = .FALSE. !< Inifor flag indicating whether the I/O group has been preprocessed
+ END TYPE io_group 
+
+
+ TYPE container
+   REAL(dp), ALLOCATABLE ::  array(:,:,:)
+   LOGICAL               ::  is_preprocessed = .FALSE.
+ END TYPE container
+
+ END MODULE types
+
Index: palm/trunk/UTIL/inifor/src/util.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/util.f90	(revision 2696)
+++ palm/trunk/UTIL/inifor/src/util.f90	(revision 2696)
@@ -0,0 +1,343 @@
+!> @file src/util.f90
+!------------------------------------------------------------------------------!
+! This file is part of PALM/PALM-4U.
+!
+! PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+! the terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later 
+! version.
+!
+! PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+! Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> The util module provides miscellaneous utility routines for INIFOR.
+!------------------------------------------------------------------------------!
+ MODULE util
+
+    USE, INTRINSIC :: ISO_C_BINDING,                                           &
+        ONLY :  C_CHAR, C_INT, C_PTR, C_SIZE_T
+    USE defs,                                                                  &
+        ONLY :  dp, PI, DATE
+
+    IMPLICIT NONE
+
+    TYPE, BIND(c) :: tm_struct
+       INTEGER(C_INT) :: tm_sec     !< seconds after the minute [0, 61]
+       INTEGER(C_INT) :: tm_min     !< minutes after the hour [0, 59]
+       INTEGER(C_INT) :: tm_hour    !< hours since midnight [0, 23]
+       INTEGER(C_INT) :: tm_mday    !< day of the month [1, 31]
+       INTEGER(C_INT) :: tm_mon     !< month since January [0, 11]
+       INTEGER(C_INT) :: tm_year    !< years since 1900
+       INTEGER(C_INT) :: tm_wday    !< days since Sunday [0, 6]
+       INTEGER(C_INT) :: tm_yday    !< days since January 1st [0, 356]
+       INTEGER(C_INT) :: tm_isdst   !< Daylight Saving Time flag
+    END TYPE
+
+    INTERFACE
+
+       FUNCTION strptime(string, format, timeinfo) BIND(c, NAME='strptime')
+          IMPORT :: C_CHAR, C_SIZE_T, tm_struct
+
+          IMPLICIT NONE
+
+          CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) ::  string, format
+          TYPE(tm_struct), INTENT(OUT)                     ::  timeinfo
+
+          INTEGER(C_SIZE_T)                                ::  strptime
+       END FUNCTION
+
+
+       FUNCTION strftime(string, string_len, format, timeinfo) BIND(c, NAME='strftime')
+          IMPORT :: C_CHAR, C_SIZE_T, tm_struct
+
+          IMPLICIT NONE
+
+          CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(OUT) ::  string
+          CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN)  ::  format
+          INTEGER(C_SIZE_T), INTENT(IN)                     ::  string_len
+          TYPE(tm_struct), INTENT(IN)                       ::  timeinfo
+
+          INTEGER(C_SIZE_T)                                 ::  strftime
+       END FUNCTION
+
+
+       FUNCTION mktime(timeinfo) BIND(c, NAME='mktime')
+          IMPORT :: C_PTR, tm_struct
+
+          IMPLICIT NONE
+
+          TYPE(tm_struct), INTENT(IN) ::  timeinfo
+
+          TYPE(C_PTR)                 ::  mktime
+       END FUNCTION
+
+    END INTERFACE
+
+ CONTAINS
+
+    CHARACTER(LEN=DATE) FUNCTION add_hours_to(date_string, hours)
+       CHARACTER(LEN=DATE), INTENT(IN)          ::  date_string
+       INTEGER, INTENT(IN)                      ::  hours
+
+       CHARACTER(KIND=C_CHAR, LEN=*), PARAMETER ::  format_string = "%Y%m%d%H"
+       CHARACTER(KIND=C_CHAR, LEN=DATE)         ::  c_date_string
+       TYPE(C_PTR)                              ::  c_pointer
+       TYPE(tm_struct)                          ::  time_info
+       INTEGER                                  ::  err
+
+       c_date_string = date_string
+
+       ! Convert C string to C tm struct
+       CALL init_tm(time_info)
+       err = strptime(c_date_string, format_string, time_info)
+    
+       ! Manipulate and normalize C tm struct
+       time_info % tm_hour = time_info % tm_hour + hours
+       c_pointer = mktime(time_info)
+
+       ! Convert back to C string
+       err = strftime(c_date_string, INT(DATE, KIND=C_SIZE_T),                 &
+                      format_string, time_info)
+
+       add_hours_to = c_date_string
+    END FUNCTION
+
+
+    SUBROUTINE print_tm(timeinfo)
+       TYPE(tm_struct), INTENT(IN) :: timeinfo
+
+       PRINT *, "sec: ", timeinfo % tm_sec,  &  !< seconds after the minute [0, 61]
+                "min: ", timeinfo % tm_min,  &  !< minutes after the hour [0, 59]
+                "hr:  ", timeinfo % tm_hour, &  !< hours since midnight [0, 23]
+                "day: ", timeinfo % tm_mday, &  !< day of the month [1, 31]
+                "mon: ", timeinfo % tm_mon,  &  !< month since January [0, 11]
+                "yr:  ", timeinfo % tm_year, &  !< years since 1900
+                "wday:", timeinfo % tm_wday, &  !< days since Sunday [0, 6]
+                "yday:", timeinfo % tm_yday, &  !< days since January 1st [0, 356]
+                "dst: ", timeinfo % tm_isdst    !< Daylight Saving time flag
+    END SUBROUTINE print_tm
+
+    
+    SUBROUTINE init_tm(timeinfo)
+       TYPE(tm_struct), INTENT(INOUT) :: timeinfo
+
+       timeinfo % tm_sec   = 0
+       timeinfo % tm_min   = 0
+       timeinfo % tm_hour  = 0
+       timeinfo % tm_mday  = 0
+       timeinfo % tm_mon   = 0
+       timeinfo % tm_year  = 0
+       timeinfo % tm_wday  = 0
+       timeinfo % tm_yday  = 0
+
+       ! We use UTC times, so marking Daylight Saving Time (DST) 'not available'
+       ! (< 0). If this is set to 0, mktime will convert the timeinfo to DST and
+       ! add one hour.
+       timeinfo % tm_isdst = -1
+    END SUBROUTINE init_tm
+
+
+    SUBROUTINE fake_output_3d(a)
+
+       REAL(dp), INTENT(INOUT)       ::  a(:,:,:)
+       REAL(dp)                      ::  lxi, lyi
+       INTEGER ::  i,j,k
+
+       lyi = 2.0_dp * PI / (SIZE(a, 2) - 1.0_dp)
+       lxi = 2.0_dp * PI / (SIZE(a, 1) - 1.0_dp)
+
+       DO k = 1, SIZE(a, 3)
+       DO j = 1, SIZE(a, 2)
+       DO i = 1, SIZE(a, 1)
+           a(i,j,k) = SIN(lxi * i) * COS(lyi * j) + k
+       END DO
+       END DO
+       END DO
+
+    END SUBROUTINE fake_output_3d
+
+
+    SUBROUTINE fake_output_2d(a, offset)
+
+       REAL(dp), INTENT(INOUT) ::  a(:,:)
+       INTEGER, INTENT(IN)     ::  offset
+       REAL(dp)                ::  lxi, lyi
+       INTEGER                 ::  i,j
+
+       lyi = 2.0_dp*PI / (SIZE(a, 2) - 1.0_dp)
+       lxi = 2.0_dp*PI / (SIZE(a, 1) - 1.0_dp)
+
+       a(:,:) = 1.0_dp
+       DO j = 1, SIZE(a, 2)
+       DO i = 1, SIZE(a, 1)
+          a(i,j) = SIN(lxi * i) * COS(lyi * j) + offset
+       END DO
+       END DO
+
+    END SUBROUTINE fake_output_2d
+
+
+    SUBROUTINE linspace(start, stop, array)
+
+       REAL(dp), INTENT(IN)    ::  start, stop
+       REAL(dp), INTENT(INOUT) ::  array(0:)
+       INTEGER                 ::  i, n
+
+       n = UBOUND(array, 1)
+
+       IF (n .EQ. 0)  THEN
+
+          array(0) = start
+
+       ELSE
+
+          DO i = 0, n
+             array(i) = start + REAL(i, dp) / n * (stop - start)
+          END DO
+
+       END IF
+       
+    END SUBROUTINE linspace
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reverse the order of the third (vertical) array dimension from top-down
+!> (COSMO) to bottom-up (PALM)
+!------------------------------------------------------------------------------!
+    SUBROUTINE reverse(input_arr)
+
+       REAL(dp), INTENT(INOUT) ::  input_arr(:,:,:)
+
+       input_arr = input_arr(:,:,size(input_arr, 3):1:-1)
+
+    END SUBROUTINE reverse
+
+
+    SUBROUTINE deaverage(avg_1, t1, avg_2, t2, avg_3, t3)
+
+       REAL(dp), DIMENSION(:,:,:), INTENT(IN)  ::  avg_1, avg_2
+       REAL(dp), INTENT(IN)                    ::  t1, t2, t3
+       REAL(dp), DIMENSION(:,:,:), INTENT(OUT) ::  avg_3
+
+       REAL(dp)                                ::  ti
+ 
+       ti = 1.0_dp / t3
+
+       avg_3(:,:,:) = ti * ( t2 * avg_2(:,:,:) - t1 * avg_1(:,:,:) )
+
+    END SUBROUTINE deaverage
+
+
+    SUBROUTINE get_basic_state(z, beta, p_sl, t_sl, rd, g, p0)
+
+       REAL(dp), INTENT(IN)  ::  z(1:)  !< height [m]
+       REAL(dp), INTENT(IN)  ::  beta   !< logarithmic lapse rate, dT / d ln(p) [K]
+       REAL(dp), INTENT(IN)  ::  p_sl   !< reference pressure [Pa]
+       REAL(dp), INTENT(IN)  ::  t_sl   !< reference tempereature [K]
+       REAL(dp), INTENT(IN)  ::  rd     !< ideal gas constant of dry air [J/kg/K]
+       REAL(dp), INTENT(IN)  ::  g      !< acceleration of Earth's gravity [m/s^2]
+       REAL(dp), INTENT(OUT) ::  p0(1:) !< COSMO-DE basic state pressure [Pa]
+       REAL(dp) ::  root_frac, factor   !< precomputed factors
+
+       factor = - t_sl / beta
+       root_frac = (2.0_dp * beta * g) / (rd * t_sl*t_sl)
+
+       p0(:) = p_sl * EXP(                                                     &
+                  factor * ( 1.0_dp - SQRT( 1.0_dp - root_frac * z(:) ) )  &
+               )
+
+    END SUBROUTINE get_basic_state
+
+
+    ! Convert a real number to a string in scientific notation
+    ! showing four significant digits.
+    CHARACTER(LEN=11) FUNCTION real_to_str(val, format)
+
+        REAL(dp), INTENT(IN)                   ::  val
+        CHARACTER(LEN=*), OPTIONAL, INTENT(IN) ::  format
+
+        IF (PRESENT(format))  THEN
+           WRITE(real_to_str, TRIM(format)) val
+        ELSE
+           WRITE(real_to_str, '(E11.4)') val
+           real_to_str = ADJUSTL(real_to_str)
+        END IF
+
+    END FUNCTION real_to_str
+
+
+    CHARACTER(LEN=12) FUNCTION real_to_str_f(val)
+
+        REAL(dp), INTENT(IN) ::  val
+
+        WRITE(real_to_str_f, '(F12.4)') val
+        real_to_str_f = ADJUSTL(real_to_str_f)
+
+    END FUNCTION real_to_str_f
+
+
+    CHARACTER(LEN=10) FUNCTION str(val)
+
+        INTEGER, INTENT(IN) ::  val
+
+        WRITE(str, '(i10)') val
+        str = ADJUSTL(str)
+
+    END FUNCTION str
+
+
+    CHARACTER(LEN=30) FUNCTION strs(vals)
+
+        INTEGER, INTENT(IN) ::  vals(:)
+        INTEGER ::  i
+
+        strs = ''
+        DO i = 1, SIZE(vals)
+           strs = TRIM(strs) // TRIM(str(vals(i)))
+        END DO
+
+    END FUNCTION strs
+
+
+    SUBROUTINE normalize_path(path)
+        
+        CHARACTER(LEN=*), INTENT(INOUT) ::  path
+        INTEGER ::  n
+
+        n = LEN_TRIM(path)
+
+        IF (path(n:n) .NE. '/')  THEN
+           path = TRIM(path) // '/'
+        END IF
+
+    END SUBROUTINE
+
+ END MODULE
+
Index: palm/trunk/UTIL/inifor/tests/Makefile
===================================================================
--- palm/trunk/UTIL/inifor/tests/Makefile	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/Makefile	(revision 2696)
@@ -0,0 +1,92 @@
+#------------------------------------------------------------------------------!
+# This file is part of PALM/PALM-4U.
+#
+# PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation, either version 3 of the License, or (at your option) any later 
+# version.
+#
+# PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# PALM. If not, see <http://www.gnu.org/licenses/>.
+#
+# Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+# Offenbach
+#------------------------------------------------------------------------------!
+#
+# Current revisions:
+# -----------------
+# 
+# 
+# Former revisions:
+# -----------------
+# $Id$
+# Initial revision
+#
+# 
+#
+# Authors:
+# --------
+# @author Eckhard Kadasch
+#
+# Description:
+# ------------
+# This makefile is called from INIFOR's main makefile to compile and run tests.
+#------------------------------------------------------------------------------!
+PROJECT = inifor
+PROJECT_PATH = ..
+BIN_PATH = $(PROJECT_PATH)/bin
+SRC_PATH = $(PROJECT_PATH)/src
+TESTS    = $(patsubst %.f90,%,$(wildcard test-*.f90))
+
+MODULES = util.mod $(SRC_PATH)/defs.mod $(SRC_PATH)/control.mod $(SRC_PATH)/util.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+SOURCES = $(MODULES:%.mod=%.f90)
+OBJECTS = $(SOURCES:%.f90=%.o)
+
+FC      = gfortran
+FFLAGS  = -g -Wall -fdefault-real-8 \
+		  -ffpe-trap=invalid,zero,underflow,overflow
+INCLUDE = -I$(SRC_PATH)
+LIBRARY = -L/home/ekadasch/local/lib64 -lnetcdff -lutil
+		 
+.PHONY: clean test $(PROJECT)
+
+test: information $(PROJECT) $(TESTS)
+
+information:
+	@echo $(TESTS)
+
+$(PROJECT):
+	$(MAKE) -C $(PROJECT_PATH) $(PROJECT)
+
+test-grid: $(OBJECTS) $(MODULES) test-grid.o test-grid.mod util.mod util.o
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) $@.o -o $(BIN_PATH)/$@ $(INCLUDE) $(LIBRARY)
+	$(BIN_PATH)/$@
+
+# $(TESTS) expands to files of this pattern:
+test-%: $(OBJECTS) $(MODULES) test-%.o test-%.mod
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) $@.o -o $(BIN_PATH)/$@ $(INCLUDE) $(LIBRARY)
+	$(BIN_PATH)/$@
+
+%.o: %.mod
+
+util.o: util.f90
+	$(FC) $(FFLAGS) -c $< -o $@
+
+util.mod: util.f90
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o)
+
+test-%.o: test-%.f90
+	$(FC) $(FFLAGS) -c $< -o $@ $(INCLUDE)
+
+test-%.mod: test-%.f90
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o) $(INCLUDE)
+
+clean:
+	rm -rf *.mod *.o
+	rm -rf $(BIN_PATH)/test-*
Index: palm/trunk/UTIL/inifor/tests/Makefile.gnu
===================================================================
--- palm/trunk/UTIL/inifor/tests/Makefile.gnu	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/Makefile.gnu	(revision 2696)
@@ -0,0 +1,93 @@
+#------------------------------------------------------------------------------!
+# This file is part of PALM/PALM-4U.
+#
+# PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation, either version 3 of the License, or (at your option) any later 
+# version.
+#
+# PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# PALM. If not, see <http://www.gnu.org/licenses/>.
+#
+# Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+# Offenbach
+#------------------------------------------------------------------------------!
+#
+# Current revisions:
+# -----------------
+# 
+# 
+# Former revisions:
+# -----------------
+# $Id$
+# Initial revision
+#
+# 
+#
+# Authors:
+# --------
+# @author Eckhard Kadasch
+#
+# Description:
+# ------------
+# This file serves as a templete makefile for compiling INIFOR tests with
+# gfortran.
+#------------------------------------------------------------------------------!
+PROJECT = inifor
+PROJECT_PATH = ..
+BIN_PATH = $(PROJECT_PATH)/bin
+SRC_PATH = $(PROJECT_PATH)/src
+TESTS    = $(patsubst %.f90,%,$(wildcard test-*.f90))
+
+MODULES = util.mod $(SRC_PATH)/defs.mod $(SRC_PATH)/control.mod $(SRC_PATH)/util.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+SOURCES = $(MODULES:%.mod=%.f90)
+OBJECTS = $(SOURCES:%.f90=%.o)
+
+FC      = gfortran
+FFLAGS  = -g -Wall -fdefault-real-8 \
+		  -ffpe-trap=invalid,zero,underflow,overflow
+INCLUDE = -I/home/ekadasch/local/include -I$(SRC_PATH)
+LIBRARY = -L/home/ekadasch/local/lib64 -lnetcdff -lutil
+		 
+.PHONY: clean test $(PROJECT)
+
+test: information $(PROJECT) $(TESTS)
+
+information:
+	@echo $(TESTS)
+
+$(PROJECT):
+	$(MAKE) -C $(PROJECT_PATH) $(PROJECT)
+
+test-grid: $(OBJECTS) $(MODULES) test-grid.o test-grid.mod util.mod util.o
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) $@.o -o $(BIN_PATH)/$@ -I$(SRC_PATH) $(LIBRARY)
+	$(BIN_PATH)/$@
+
+# $(TESTS) expands to files of this pattern:
+test-%: $(OBJECTS) $(MODULES) test-%.o test-%.mod
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) $@.o -o $(BIN_PATH)/$@ -I$(SRC_PATH) $(LIBRARY)
+	$(BIN_PATH)/$@
+
+%.o: %.mod
+
+util.o: util.f90
+	$(FC) $(FFLAGS) -c $< -o $@
+
+util.mod: util.f90
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o)
+
+test-%.o: test-%.f90
+	$(FC) $(FFLAGS) -c $< -o $@ $(INCLUDE)
+
+test-%.mod: test-%.f90
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o) $(INCLUDE)
+
+clean:
+	rm -rf *.mod *.o
+	rm -rf $(BIN_PATH)/test-*
Index: palm/trunk/UTIL/inifor/tests/Makefile.ifort
===================================================================
--- palm/trunk/UTIL/inifor/tests/Makefile.ifort	(revision 2696)
+++ palm/trunk/UTIL/inifor/tests/Makefile.ifort	(revision 2696)
@@ -0,0 +1,92 @@
+#------------------------------------------------------------------------------!
+# This file is part of PALM/PALM-4U.
+#
+# PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation, either version 3 of the License, or (at your option) any later 
+# version.
+#
+# PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# PALM. If not, see <http://www.gnu.org/licenses/>.
+#
+# Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+# Offenbach
+#------------------------------------------------------------------------------!
+#
+# Current revisions:
+# -----------------
+# 
+# 
+# Former revisions:
+# -----------------
+# $Id$
+# Initial revision
+#
+# 
+#
+# Authors:
+# --------
+# @author Eckhard Kadasch
+#
+# Description:
+# ------------
+# This file serves as a templete makefile for compiling INIFOR tests with
+# ifort.
+#------------------------------------------------------------------------------!
+PROJECT = inifor
+PROJECT_PATH = ..
+BIN_PATH = $(PROJECT_PATH)/bin
+SRC_PATH = $(PROJECT_PATH)/src
+TESTS    = $(patsubst %.f90,%,$(wildcard test-*.f90))
+
+MODULES = util.mod $(SRC_PATH)/defs.mod $(SRC_PATH)/control.mod $(SRC_PATH)/util.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+SOURCES = $(MODULES:%.mod=%.f90)
+OBJECTS = $(SOURCES:%.f90=%.o)
+
+FC      = ifort
+FFLAGS  = -g -real-size 64 -no-wrap-margin
+INCLUDE = -I$(SRC_PATH)
+LIBRARY = -L/usr/local/pkg/netcdf/4.3.2/lib -lnetcdff -lutil
+
+.PHONY: clean test $(PROJECT)
+
+test: information $(PROJECT) $(TESTS)
+
+information:
+	@echo $(TESTS)
+
+$(PROJECT):
+	$(MAKE) -C $(PROJECT_PATH) $(PROJECT)
+
+test-grid: $(OBJECTS) $(MODULES) test-grid.o test-grid.mod util.mod util.o
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) $@.o -o $(BIN_PATH)/$@ $(INCLUDE) $(LIBRARY)
+	$(BIN_PATH)/$@
+
+# $(TESTS) expands to files of this pattern:
+test-%: $(OBJECTS) $(MODULES) test-%.o test-%.mod
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) $@.o -o $(BIN_PATH)/$@ $(INCLUDE) $(LIBRARY)
+	$(BIN_PATH)/$@
+
+%.o: %.mod
+
+util.o: util.f90
+	$(FC) $(FFLAGS) -c $< -o $@
+
+util.mod: util.f90
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o)
+
+test-%.o: test-%.f90
+	$(FC) $(FFLAGS) -c $< -o $@ $(INCLUDE)
+
+test-%.mod: test-%.f90
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o) $(INCLUDE)
+
+clean:
+	rm -rf *.mod *.o
+	rm -rf $(BIN_PATH)/test-*
